routes/web.php
<?php

use App\Http\Controllers\AddressController;
use App\Http\Controllers\Auth\LoginController;
use App\Http\Controllers\BrandController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CityController;
use App\Http\Controllers\CKEditorController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\ConsultationController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\DiscountController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\MenuController;
use App\Http\Controllers\NewsletterController;
use App\Http\Controllers\OrderController;
use App\Http\Controllers\PageController;
use App\Http\Controllers\PaymentController;
use App\Http\Controllers\PostController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProductKeyController;
use App\Http\Controllers\ProductValueController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SearchHistoryController;
use App\Http\Controllers\ShoppingCartController;
use App\Http\Controllers\TicketController;
use App\Http\Controllers\TicketMessageController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});


Route::get('/clear-cache', function() {
    $exitCode = Artisan::call('cache:clear');
    // return what you want
});

Auth::routes();

//Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::group(["prefix"=>"panel","as"=>"admin.",'middleware' => ["auth","role:super-admin"]],function (){
    Route::get("/dashboard",[DashboardController::class,"index"])->name("dashboard.index");

    Route::post('/ckeditor/upload',[CKEditorController::class,"upload"])->name("ckeditor.upload");

    // category route
    Route::get('/categories',[CategoryController::class,"index"])->name("categories.index");
    Route::get('/categories/create',[CategoryController::class,"create"])->name("categories.create");
    Route::post('/categories/{category:slug?}',[CategoryController::class,"store"])->name("categories.store");
    Route::get('/categories/{category:slug}/edit',[CategoryController::class,"edit"])->name("categories.edit");
    Route::get('/categories/{category:slug}',[CategoryController::class,"destroy"])->name("categories.destroy");

    // post route
    Route::get('/posts',[PostController::class,"index"])->name("posts.index");
    Route::get('/posts/create',[PostController::class,"create"])->name("posts.create");
    Route::post('/posts/{post:slug?}',[PostController::class,"store"])->name("posts.store");
    Route::get('/posts/{post:slug}/edit',[PostController::class,"edit"])->name("posts.edit");
    Route::get('/posts/{post:slug}',[PostController::class,"destroy"])->name("posts.destroy");

    // comments  route
    Route::get('/comments',[CommentController::class,"index"])->name("comments.index");
    Route::get('/comments/create',[CommentController::class,"create"])->name("comments.create");
    Route::post('/comments/{comment:id?}',[CommentController::class,"store"])->name("comments.store");
    Route::get('/comments/{comment:id}/edit',[CommentController::class,"edit"])->name("comments.edit");
    Route::get('/comments/{comment:id}',[CommentController:: class,"destroy"])->name("comments.destroy");

    // brand route
    Route::get('/brands',[BrandController::class,"index"])->name("brands.index");
    Route::get('/brands/create',[BrandController::class,"create"])->name("brands.create");
    Route::post('/brands/{brand:slug?}',[BrandController::class,"store"])->name("brands.store");
    Route::get('/brands/{brand:slug}/edit',[BrandController::class,"edit"])->name("brands.edit");
    Route::get('/brands/{brand:slug}',[BrandController::class,"destroy"])->name("brands.destroy");

    // product keys route
    Route::get('/keys',[ProductKeyController::class,"index"])->name("keys.index");
    Route::get('/keys/create',[ProductKeyController::class,"create"])->name("keys.create");
    Route::post('/keys/{key:id?}',[ProductKeyController::class,"store"])->name("keys.store");
    Route::get('/keys/{key:id}/edit',[ProductKeyController::class,"edit"])->name("keys.edit");
    Route::get('/keys/{key:id}',[ProductKeyController:: class,"destroy"])->name("keys.destroy");

    // product values route
    Route::get('/values',[ProductValueController::class,"index"])->name("values.index");
    Route::get('/values/create',[ProductValueController::class,"create"])->name("values.create");
    Route::post('/values/{value:id?}',[ProductValueController::class,"store"])->name("values.store");
    Route::get('/values/{value:id}/edit',[ProductValueController::class,"edit"])->name("values.edit");
    Route::get('/values/{value:id}',[ProductValueController:: class,"destroy"])->name("values.destroy");
    Route::get('/ajax-values',[ProductValueController:: class,"getByKeyAjax"])->name("values.by.Key.ajax");

    // product  route
    Route::get('/products',[ProductController::class,"index"])->name("products.index");
    Route::get('/products/create',[ProductController::class,"create"])->name("products.create");
    Route::post('/products/{product:slug?}',[ProductController::class,"store"])->name("products.store");
    Route::get('/products/{product:slug}/edit',[ProductController::class,"edit"])->name("products.edit");
    Route::get('/products/{product:slug}',[ProductController:: class,"destroy"])->name("products.destroy");

    // orders  route
    Route::get('/orders',[OrderController::class,"index"])->name("orders.index");
    Route::get('/orders/create',[OrderController::class,"create"])->name("orders.create");
    Route::post('/orders/{order:id?}',[OrderController::class,"store"])->name("orders.store");
    Route::get('/orders/{order:id}/edit',[OrderController::class,"edit"])->name("orders.edit");
    Route::get('/orders/{order:id}',[OrderController:: class,"destroy"])->name("orders.destroy");
    Route::get('/orders/change-status/{order:id}/{status}',[OrderController:: class,"changeStatus"])->name("orders.change.status");

    Route::get("tickets",[TicketController::class,"index"])->name("ticket.index");
    Route::get("tickets/{ticket:code}",[TicketController::class,"detail"])->name("ticket.detail");
    Route::get("tickets/close/{ticket:code}",[TicketController::class,"close"])->name("ticket.close");
    Route::get("tickets/close/{ticket:code}",[TicketController::class,"close"])->name("ticket.close");

    //menu route
    Route::get("menu",[MenuController::class,"index"])->name("menu.index");
    Route::get("menu/new",[MenuController::class,"create"])->name("menu.create");
    Route::get("menu/edit/{menu:id}",[MenuController::class,"edit"])->name("menu.edit");
    Route::post("menu/new/{menu:id?}",[MenuController::class,"store"])->name("menu.store");
    Route::get("menu/delete/{menu:id}",[MenuController::class,"destroy"])->name("menu.destroy");

    //page route
    Route::get("pages",[PageController::class,"index"])->name("page.index");
    Route::get("pages/new",[PageController::class,"create"])->name("page.create");
    Route::get("pages/edit/{page:slug}",[PageController::class,"edit"])->name("page.edit");
    Route::post("pages/new/{page:slug?}",[PageController::class,"store"])->name("page.store");
    Route::get("pages/delete/{page:slug}",[PageController::class,"destroy"])->name("page.destroy");

    Route::get("consultations",[ConsultationController::class,"index"])->name("consultations.index");
    Route::get("newsletter",[NewsletterController::class,"index"])->name("newsletter.index");
});

Route::group(["prefix"=>"profile","as"=>"profile.",'middleware' => ["auth","role:user"]],function (){
    Route::get("/",[ProfileController::class,"index"])->name("index");
    Route::get("/edit",[ProfileController::class,"profileEdit"])->name("edit");
    Route::post("/getCitiesAjax",[CityController::class,"getCitiesAjax"])->name("cities.ajax");
    Route::post("/update",[ProfileController::class,"updateProfile"])->name("profile.update");
    Route::get("/address",[AddressController::class,"address"])->name("address.index");
    Route::post("/address/create",[AddressController::class,"store"])->name("address.create");
    Route::get("/orders",[OrderController::class,"orderProfile"])->name("order.index");
    Route::get("/orders/{order:refuse_id}",[OrderController::class,"orderProfileDetail"])->name("order.detail");
    Route::get("/tickets",[TicketController::class,"profileTicket"])->name("ticket.index");
    Route::get("/tickets/new",[TicketController::class,"profileNewTicket"])->name("ticket.new");
    Route::get("/tickets/{ticket:code}",[TicketController::class,"profileTicketDetail"])->name("ticket.detail");
    Route::post("/tickets/create",[TicketController::class,"store"])->name("ticket.store");
    Route::post("/tickets-message/create/{ticket:code}",[TicketMessageController::class,"store"])->name("ticket.message.store");
    Route::post('/post/{post:slug}',[PostController::class,"storeComment"])->name("post.comment.store");
    Route::post('/product/{product:slug}',[ProductController::class,"storeComment"])->name("product.comment.store");
    Route::get("/payments",[PaymentController::class,"paymentProfile"])->name("payment.index");

    Route::get('/checkout', [ShoppingCartController::class, 'checkout'])->name('shopping-cart.checkout');
    Route::post('/order/submit', [ShoppingCartController::class, 'SendPayment'])->name('shopping-cart.payment.send');
    Route::get('/verify', [PaymentController::class, 'verify'])->name('payment.verify');

});


Route::group(["middleware" => "redirect"],function (){

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Helpers\Convert;
use App\Helpers\Images;
use App\Models\ProductValueModel;
use App\Services\Brand\BrandService;
use App\Services\Category\CategoryService;
use App\Services\Gallery\GalleryService;
use App\Services\ProductDetail\ProductDetailService;
use App\Services\ProductKey\ProductKeyService;
use App\Services\ProductValue\ProductValueService;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use App\Models\ProductModel;
use App\Services\Product\ProductService;
use Illuminate\Support\Facades\App;
use App\Http\Requests\ProductRequest;

class ProductController extends Controller
{

    public ProductService $productService;
    public CategoryService $categoryService;
    public BrandService $brandService;
    public ProductKeyService $productKeyService;
    public ProductDetailService $productDetailService;
    public ProductValueService $productValueService;
    public GalleryService $galleryService;

    public function __construct()
    {
        $this->productService = App::make(ProductService::class);
        $this->categoryService = App::make(CategoryService::class);
        $this->brandService = App::make(BrandService::class);
        $this->productKeyService = App::make(ProductKeyService::class);
        $this->productDetailService = App::make(ProductDetailService::class);
        $this->productValueService = App::make(ProductValueService::class);
        $this->galleryService = App::make(GalleryService::class);
    }

    public function index()
    {

        if(request()->ajax()){
            return datatables()->of($this->productService->all())
                ->addColumn('action', function ($row) {
                    return view('panel.products.buttons')->with("row",$row);
                })
                ->addColumn('category', function ($row) {
                    return view('panel.products.categories')->with("row",$row);
                })
                ->editColumn('price', function ($row) {
                    return number_format($row->price);
                })
                ->editColumn('thumbnail', function ($row) {
                    return view('panel.products.thumbnail')->with("row",$row);
                })
                ->addIndexColumn()
                ->rawColumns(['brand','action','category'])
                ->make(true);
        }
        return view("panel.products.index");
    }

    public function create()
    {
        $categories = $this->categoryService->all();
        $brands     = $this->brandService->all();
        $keys       = $this->productKeyService->all();
        return view("panel.products.new",compact("categories","brands","keys"));
    }

    public function edit(ProductModel $product)
    {
        $categories = $this->categoryService->all();
        $brands     = $this->brandService->all();
        $keys       = $this->productKeyService->all();

        $values=ProductValueModel::all();
        return view("panel.products.edit",compact("product","categories","brands","keys","values"));
    }

    public function store(ProductRequest $request, ProductModel $product = null)
    {
        $productData = $request->all();
        $productData["price"] = Convert::priceFormat($productData["price"]);
        if($request->file("thumbnail")){
            $image = new Images();
            $thumbnailName = $image->uploadFile($request,"thumbnail",config("upload_image_path.product-thumbnail"));
            $productData["thumbnail"] = $thumbnailName;
        }

        if(array_key_exists("seo_image",$productData)){
            $image = new Images();
            $thumbnailName = $image->uploadFile($request,"seo_image",config("upload_image_path.seo-image"));
            $productData["seo_image"] = $thumbnailName;
        }

        if(!array_key_exists("indexable",$productData)){
            $productData["indexable"] = 0;
        }
        if(!array_key_exists("exist",$productData)){
            $productData["exist"] = 0;
        }
        if(!array_key_exists("commentable",$productData)){
            $productData["commentable"] = 0;
        }

        $product ? $this->productService->save($productData,$product->id) : $product = $this->productService->save($productData);

        if(array_key_exists("category",$productData)){
            $this->categoryService->syncCategory($product,$productData["category"]);
        } else {
            $this->categoryService->detachCategory($product);
        }

        if(array_key_exists("galleries",$productData)){
            $this->galleryService->uploadGallery($product,$productData["galleries"]);
        }

        $this->saveProductDetails($productData,$product);


        // there is a situation that product has not changed, but gallery request changed. this situation ProductObserver has not performed updated method.
        // so, we should check gallery request in the controller.
        // if request has any gallery then upload it and save to db and sync galleriables
        // and also category request

        if($product){
            return redirect()->route('admin.products.index')->with('save',true);
        }
        return abort(500);
    }

    public function saveProductDetails(array $request,ProductModel $product = null)
    {
        if(array_key_exists("product-value",$request)){
            $records = [];
            $productDetailSelectable=[];
            $valueIds = $this->productDetailService->get(["product_id","=",$product->id])->pluck("product_value_id");
            $values = $request["product-value"];
//            if($valueIds->toArray() != $values){
                $this->detachProductDetails($product);
                $count = count($values);
                for($i=0;$i<=$count-1;$i++) {
                    $selectable = false;
                    if(array_key_exists($i,$request["selectable"])) {
                        $selectable = true;
                    }
                    $productDetailSelectable[$i] = $selectable;
                }
                for ($i=0;$i <= $count-1;$i++){
                    $records[$i]["product_value_id"] = $values[$i];
                    $records[$i]["price"] = $request["product-price"][$i];
                    $records[$i]["product_id"] = $product->id;
                    $records[$i]["selectable"] = $productDetailSelectable[$i];

                }

//            array_unshift($records,"");
//            unset($records[0]);
//            }
            return $this->productDetailService->createMany($records);
        }
    }

    public function detachProductDetails(ProductModel $product)
    {
        return $this->productDetailService->deleteByCondition(["product_id","=",$product->id]);
    }

    public function show(ProductModel $product)
    {
        $details = $this->productDetailService->selectable($product);
        $categoryIds = $product->categories->pluck('id')->toArray();
        $relatedProducts = ProductModel::whereHas('categories', function ($query) use ($categoryIds) {
            return $query->whereIn('id', $categoryIds);
        })->where('id',"!=", $product->id)->inRandomOrder()->limit(8)->get();
        return view("front.products.index",compact("product","details","relatedProducts"));
    }

    public function destroy(ProductModel $product)
    {
        if( $this->productService->delete($product) ){
            return redirect()->route("admin.products.index")->with("delete",true);
        }
    }

    public function storeComment(Request $request,ProductModel $product):bool
    {
        $commentData = $request->all();
        Auth::check() ? $commentData["user_id"] = Auth::id() : $commentData["user_id"] = null;
        $commentData["status"] = config("comment-status.initialRegistration");
        if($product->comments()->create($commentData)){
            return true;
        }
        return false;
    }
}

resources/views/panel/products/buttons.blade.php
<a href="{{ route("admin.products.edit",["product"=>$row->slug]) }}" class="btn btn-primary">ویرایش</a>
<a href="#" data-bs-toggle="modal" data-bs-target="#confirm-delete" class="btn btn-danger show-delete-modal" data-url-delete="{{ route("admin.products.destroy",["product"=>$row->slug]) }}">حذف</a>

resources/views/panel/products/categories.blade.php
@if($row->categories->count() > 0)
    @foreach($row->categories as $item)
        <span class="badge @if($loop->iteration == 1) badge-soft-primary @elseif($loop->iteration == 2) badge-soft-success @else badge-soft-danger @endif">{{ $item->title }}</span>
    @endforeach
@else
    -
@endif

resources/views/panel/products/index.blade.php
@extends("panel.layouts.ubold")
@section("head")
    <link rel="stylesheet" href="{{ asset("panel/assets/libs/datatables.net/jquery.dataTables.min.css") }}">
    <title>فنجان ایرانی | لیست محصولات</title>
@endsection
@section("content")
    <div class="content">
        <div class="container-fluid">
            <div class="row">
                <div class="col-12">
                    <div class="page-title-box">
                        <div class="page-title-right">
                            <ol class="breadcrumb m-0">
                                <li class="breadcrumb-item"><a href="javascript: void(0);">داشبورد</a></li>
                                <li class="breadcrumb-item active">لیست محصولات</li>
                            </ol>
                        </div>
                        <h4 class="page-title d-inline-block">لیست محصولات</h4>
                        <a href="{{ route("admin.products.create") }}" class="btn btn-primary btn-rounded waves-effect waves-light d-inline-block mr-3">
                            <span class="btn-label"><i class="mdi mdi-plus"></i></span>
                            ایجاد محصول جدید
                        </a>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12 col-xl-12">
                    <div class="card">
                        <div class="card-body">
                            @include("panel.partials.notifications")
                            <div class="table-responsive">
                                <table id="datatable" class="table table-striped align-middle text-center w-100">
                                    <thead>
                                    <tr>
                                        <th>#</th>
                                        <th>تصویر</th>
                                        <th>عنوان</th>
                                        <th>دسته</th>
                                        <th>ایندکس</th>
                                        <th>قیمت</th>
                                        <th>موجود</th>
                                        <th>عملیات</th>
                                    </tr>
                                    </thead>
                                    <tbody>

                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="modal fade" id="confirm-delete" data-bs-backdrop="static" data-bs-keyboard="false">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title uc-first">حذف محصول</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <p>محصول حذف خواهد شد. آیا مطمئن هستید؟</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">بستن</button>
                    <a href="#" class="btn btn-danger btn-delete">بله حذفش کن!</a>
                </div>
            </div>
        </div>
    </div>
@endsection
@section("script")
    <script type="text/javascript" charset="utf8" src="{{ asset("https://cdn.datatables.net/1.12.0/js/jquery.dataTables.min.js") }}"></script>
    <script type="text/javascript" charset="utf8" src="{{ asset("https://cdn.datatables.net/fixedcolumns/4.1.0/js/dataTables.fixedColumns.min.js") }}"></script>
    <script>

        let url;
        $(document).on("click", ".show-delete-modal", (function (event) {
            url = $(this).attr("data-url-delete");
            $(".btn-delete").attr("href",url);
        }));

        $('#datatable thead tr').clone(true).appendTo( '#datatable thead' );
        $('#datatable thead tr:eq(1) th').each( function (i) {
            if(i !== 0){
                var title = $(this).text();
                $(this).html( '<input type="text" placeholder="جستجوی '+title+'" />' );
            }
            $( 'input', this ).on( 'change change', function () {
                if ( table.column(i).search() !== this.value ) {
                    table
                        .column(i)
                        .search( this.value )
                        .draw();
                }
            } );
        });

        $('#datatable').on('processing.dt',function( e, settings, processing ){
            if (processing){
                $("tbody").html('');
                $("tbody").css('height',"300px");
                $("tbody").append('<tr><td colspan="10"><div id="loading"></div></td></tr>');
            }else {
                $('#loading').hide();
                $("tbody").css('height',"auto");
            }
        });

        var table = $('#datatable').DataTable({
            fixedHeader: false,
            orderCellsTop: true,
            serverSide: true,
            "autoWidth": true,
            "language": {
                "url": "//cdn.datatables.net/plug-ins/1.10.19/i18n/Persian.json"
            },
            "scrollX": true,
            ajax: "{{ route('admin.products.index') }}",
            columns: [
                {data: 'DT_RowIndex', name: 'DT_RowIndex'},
                {data: 'thumbnail', name: 'thumbnail'},
                {data: 'title', name: 'title'},
                {data: 'category', name: 'category'},
                {data: 'indexable', name: 'indexable'},
                {data: 'price', name: 'price'},
                {data: 'exist', name: 'exist'},
                {data: 'action', name: 'action'},
            ],
        });
    </script>
@endsection

resources/views/panel/products/thumbnail.blade.php
<img class="thumbnail" src="{{ asset("product-thumbnails/sm")."/".$row->thumbnail }}" alt="{{ $row->title }}">

resources/views/panel/products/values-ajax.blade.php
@foreach($values as $value)
    <option value="{{ $value->id }}">{{ $value->value }}</option>
@endforeach